<template>
  <div class="d-flex question-tester">
    <div class="d-flex flex-grow-1 flex-column question-tester">
      <div class="headline mb-3">Вопрос № {{ curQuestionNumber + 1 }}</div>
      <v-chip color="success mb-3">{{ questionTypeText }}</v-chip>
      <v-textarea :value="question.condition.text" readonly></v-textarea>
      <ValidationObserver tag="form" ref="observer">
        <QuestionWrapper
          v-bind="{ ...question }"
          @input="mutateQuestionFields"
          :controlConfig="{hideText: true, disabled: true, label: ''}"
          viewMode
        />
      </ValidationObserver>
      <v-btn color="success" @click="sendAnswer">Отправить</v-btn>
    </div>
  </div>
</template>
<script>
import QuestionWrapper from "@/components/Question/QuestionWrapper";
import QUESTION_TYPES from "@/utils/question_types.js";
import Validatable from "@/mixins/Validatable";
export default {
  components: {
    QuestionWrapper
  },
  mixins: [Validatable],
  props: {
    curQuestionNumber: {
      type: Number
    },
    question: {
      type: Object,
      default: () => {}
    }
  },
  data() {
    return {
      id: this.question?._id || null,
      title: this.question?.title || "",
      type: this.question?.type || null,
      result: this.question?.result || null,
      variants: this.question?.variants || [],
      condition: this.question?.condition || {},
      text: this.question?.text || "",
      point: this.question?.point || 1
    };
  },
  watch: {
    question: {
      deep: true,
      handler(v) {
        if (v) {
          this.reset();
          const {
            _id,
            title,
            type,
            result,
            variants,
            condition,
            value,
            point
          } = v;
          this._id = _id;
          this.title = title;
          this.type = type;
          this.result = result;
          this.variants = variants;
          this.condition = condition;
          this.value = value;
          this.point = point;
        } else {
          this.reset();
        }
      }
    }
  },
  methods: {
    reset() {
      this._id = null;
      this.title = null;
      this.type = null;
      this.result = {};
      this.variants = [];
      this.value = null;
      this.condition = null;
      this.point = 1;
    },
    async sendAnswer() {
      const isValid = await this.$refs.observer.validate();

      if (isValid) {
        const { _id, result } = this;

        this.$emit("send-answer", { value: result, questionId: _id });
        return;
      }
    },
    mutateQuestionFields(v) {
      Object.entries(v).forEach(([key, value]) => (this[key] = value));
    }
  },
  computed: {
    questionTypeText() {
      const questionType = QUESTION_TYPES.find(
        type => this.question.type === type.value
      );

      return questionType?.text;
    }
  }
};
</script>
<style lang="scss">
.question-tester {
  max-width: 500px;
}
</style>